Backend API
$(() => {
const provider = new DevExpress.fileManagement.RemoteFileSystemProvider({
endpointUrl: 'https://js.devexpress.com/Demos/NetCore/api/file-manager-db',
});
$('#file-manager').dxFileManager({
name: 'fileManager',
currentPath: 'Documents/Reports',
fileSystemProvider: provider,
permissions: {
create: true,
copy: true,
move: true,
delete: true,
rename: true,
},
itemView: {
details: {
columns: [
'thumbnail', 'name',
{
dataField: 'dateModified',
caption: 'Modified',
},
{
dataField: 'created',
caption: 'Created',
dataType: 'date',
},
{
dataField: 'modifiedBy',
caption: 'Modified By',
visibleIndex: 2,
},
],
},
},
allowedFileExtensions: [],
height: 550,
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="index.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="file-manager"></div>
</div>
</body>
</html>
using DevExtreme.AspNet.Mvc.FileManagement;
using DevExtreme.MVC.Demos.Models.FileManagement;
using System;
using System.Web;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class FileManagerDbProviderApiController : ApiController {
[AcceptVerbs("GET", "POST")]
[Route("api/file-manager-db", Name = "FileManagerDBProviderApi")]
public object Process(FileSystemCommand command, string arguments) {
var request = new HttpContextWrapper(HttpContext.Current).Request;
var config = new FileSystemConfiguration {
Request = request,
FileSystemProvider = new DbFileProvider(),
AllowCopy = true,
AllowCreate = true,
AllowMove = true,
AllowDelete = true,
AllowRename = true,
AllowedFileExtensions = new string[0]
};
var processor = new FileSystemCommandProcessor(config);
var result = processor.Execute(command, arguments);
return Ok(result.GetClientCommandResult());
}
}
}
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using DevExtreme.AspNet.Mvc.FileManagement;
namespace DevExtreme.MVC.Demos.Models.FileManagement {
public class DbFileProvider : IFileSystemItemLoader, IFileSystemItemEditor {
const int GuestPersonId = 1;
public DbFileProvider() {
FileManagementDbContext = new InMemoryFileManagementDataContext();
}
InMemoryFileManagementDataContext FileManagementDbContext { get; }
public IEnumerable<FileSystemItem> GetItems(FileSystemLoadItemOptions options) {
int parentId = ParseKey(options.Directory.Key);
var fileItems = GetDirectoryContents(parentId);
var hasSubDirectoriesInfo = GetHasSubDirectoriesInfo(fileItems);
var clientItemList = new List<FileSystemItem>();
foreach(var item in fileItems) {
var clientItem = new FileSystemItem {
Key = item.Id.ToString(),
Name = item.Name,
IsDirectory = item.IsDirectory,
DateModified = item.Modified
};
if(item.IsDirectory) {
clientItem.HasSubDirectories = hasSubDirectoriesInfo.ContainsKey(item.Id) && hasSubDirectoriesInfo[item.Id];
}
clientItem.CustomFields["modifiedBy"] = item.ModifiedBy.FullName;
clientItem.CustomFields["created"] = item.Created;
clientItemList.Add(clientItem);
}
return clientItemList;
}
public void CreateDirectory(FileSystemCreateDirectoryOptions options) {
var parentDirectory = options.ParentDirectory;
if(!IsFileItemExists(parentDirectory))
ThrowItemNotFoundException(parentDirectory);
var directory = new FileItem {
Name = options.DirectoryName,
Modified = DateTime.Now,
Created = DateTime.Now,
IsDirectory = true,
ParentId = ParseKey(parentDirectory.Key),
ModifiedById = GuestPersonId
};
FileManagementDbContext.FileItems.Add(directory);
FileManagementDbContext.SaveChanges();
}
public void RenameItem(FileSystemRenameItemOptions options) {
var item = options.Item;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
var fileItem = GetFileItem(item);
fileItem.Name = options.ItemNewName;
fileItem.ModifiedById = GuestPersonId;
fileItem.Modified = DateTime.Now;
FileManagementDbContext.SaveChanges();
}
public void MoveItem(FileSystemMoveItemOptions options) {
var item = options.Item;
var destinationDirectory = options.DestinationDirectory;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
if(!IsFileItemExists(destinationDirectory))
ThrowItemNotFoundException(destinationDirectory);
if(!AllowCopyOrMove(item, destinationDirectory))
ThrowNoAccessException();
var fileItem = GetFileItem(item);
fileItem.ParentId = ParseKey(destinationDirectory.Key);
fileItem.Modified = DateTime.Now;
fileItem.ModifiedById = GuestPersonId;
FileManagementDbContext.SaveChanges();
}
public void CopyItem(FileSystemCopyItemOptions options) {
var item = options.Item;
var destinationDirectory = options.DestinationDirectory;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
if(!IsFileItemExists(destinationDirectory))
ThrowItemNotFoundException(destinationDirectory);
if(!AllowCopyOrMove(item, destinationDirectory))
ThrowNoAccessException();
var sourceFileItem = GetFileItem(item);
var copyFileItem = CreateCopy(sourceFileItem);
copyFileItem.ParentId = ParseKey(destinationDirectory.Key);
copyFileItem.Name = GenerateCopiedFileItemName(copyFileItem.ParentId, copyFileItem.Name, copyFileItem.IsDirectory);
FileManagementDbContext.FileItems.Add(copyFileItem);
if(copyFileItem.IsDirectory)
CopyDirectoryContentRecursive(sourceFileItem, copyFileItem);
FileManagementDbContext.SaveChanges();
}
void CopyDirectoryContentRecursive(FileItem sourcePathInfo, FileItem destinationPathInfo) {
foreach(var fileItem in GetDirectoryContents(sourcePathInfo.Id)) {
var copyItem = CreateCopy(fileItem);
copyItem.Parent = destinationPathInfo;
FileManagementDbContext.FileItems.Add(copyItem);
if(fileItem.IsDirectory)
CopyDirectoryContentRecursive(fileItem, copyItem);
}
}
public void DeleteItem(FileSystemDeleteItemOptions options) {
var item = options.Item;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
var fileItem = GetFileItem(item);
FileManagementDbContext.FileItems.Remove(fileItem);
if(fileItem.IsDirectory)
RemoveDirectoryContentRecursive(fileItem.Id);
FileManagementDbContext.SaveChanges();
}
void RemoveDirectoryContentRecursive(int parenDirectoryKey) {
var itemsToRemove = FileManagementDbContext
.FileItems
.Where(item => item.ParentId == parenDirectoryKey)
.Select(item => new FileItem {
Id = item.Id,
IsDirectory = item.IsDirectory
});
foreach(var item in itemsToRemove) {
FileManagementDbContext.FileItems.Remove(item);
}
foreach(var item in itemsToRemove) {
if(!item.IsDirectory) continue;
RemoveDirectoryContentRecursive(item.Id);
}
}
IEnumerable<FileItem> GetDirectoryContents(int parentKey) {
return FileManagementDbContext.FileItems
.OrderByDescending(item => item.IsDirectory)
.ThenBy(item => item.Name)
.Where(items => items.ParentId == parentKey);
}
IDictionary<int, bool> GetHasSubDirectoriesInfo(IEnumerable<FileItem> fileItems) {
var keys = fileItems.Select(i => i.Id).ToArray();
return FileManagementDbContext.FileItems
.Where(item => item.IsDirectory)
.GroupBy(i => i.ParentId)
.Where(i => keys.Contains(i.Key))
.ToDictionary(group => group.Key, group => group.Any());
}
FileItem GetFileItem(FileSystemItemInfo item) {
var itemId = ParseKey(item.Key);
return FileManagementDbContext.FileItems.FirstOrDefault(i => i.Id == itemId);
}
bool IsFileItemExists(FileSystemItemInfo itemInfo) {
var pathKeys = itemInfo.PathKeys.Select(key => ParseKey(key)).ToArray();
var foundEntries = FileManagementDbContext.FileItems
.Where(item => pathKeys.Contains(item.Id))
.Select(item => new { item.Id, item.ParentId, item.Name, item.IsDirectory });
var pathNames = itemInfo.Path.Split(new[] { Path.DirectorySeparatorChar }, StringSplitOptions.RemoveEmptyEntries);
var isDirectoryExists = true;
for(var i = 0; i < pathKeys.Length && isDirectoryExists; i++) {
var entry = foundEntries.FirstOrDefault(e => e.Id == pathKeys[i]);
isDirectoryExists = entry != null && entry.Name == pathNames[i] &&
(i == 0 && entry.ParentId == 0 || entry.ParentId == pathKeys[i - 1]);
if(isDirectoryExists && i < pathKeys.Length - 1)
isDirectoryExists = entry.IsDirectory;
}
return isDirectoryExists;
}
static bool AllowCopyOrMove(FileSystemItemInfo item, FileSystemItemInfo destinationDirectory) {
if(destinationDirectory.PathKeys.Length < item.PathKeys.Length)
return true;
var isValid = false;
for(var i = 0; i < destinationDirectory.PathKeys.Length && !isValid; i++) {
isValid = destinationDirectory.PathKeys[i] != item.PathKeys[i];
}
return isValid;
}
static FileItem CreateCopy(FileItem fileItem) {
return new FileItem {
Name = fileItem.Name,
Created = DateTime.Now,
Modified = DateTime.Now,
IsDirectory = fileItem.IsDirectory,
ModifiedById = GuestPersonId
};
}
static int ParseKey(string key) {
return string.IsNullOrEmpty(key) ? 0 : int.Parse(key);
}
string GenerateCopiedFileItemName(int parentDirKey, string copiedFileItemName, bool isDirectory) {
var dirNames = GetDirectoryContents(parentDirKey)
.Where(i => i.IsDirectory == isDirectory)
.Select(i => i.Name);
string newName;
var fileExtension = isDirectory ? "" : "." + Path.GetExtension(copiedFileItemName);
var copyNamePrefix =
isDirectory ? copiedFileItemName : Path.GetFileNameWithoutExtension(copiedFileItemName);
var index = -1;
do {
var pathPostfix = index < 1 ? string.Empty : $" {index}{fileExtension}";
newName = $"{copyNamePrefix} {(index < 0 ? "" : "copy")}{pathPostfix}";
index++;
} while(dirNames.Contains(newName));
return newName;
}
void ThrowItemNotFoundException(FileSystemItemInfo item) {
var itemType = item.IsDirectory ? "Directory" : "File";
var errorCode = item.IsDirectory ? FileSystemErrorCode.DirectoryNotFound : FileSystemErrorCode.FileNotFound;
string message = $"{itemType} '{item.Path}' not found.";
throw new FileSystemException(errorCode, message);
}
void ThrowNoAccessException() {
string message = "Access denied. The operation cannot be completed.";
throw new FileSystemException(FileSystemErrorCode.NoAccess, message);
}
}
}

Backend API
<dx-file-manager
id="fileManager"
[fileSystemProvider]="remoteProvider"
currentPath="Documents/Reports"
[allowedFileExtensions]="allowedFileExtensions"
height="550"
>
<dxo-file-manager-permissions
[create]="true"
[copy]="true"
[move]="true"
[delete]="true"
[rename]="true"
>
</dxo-file-manager-permissions>
<dxo-file-manager-item-view>
<dxo-file-manager-details>
<dxi-file-manager-column dataField="thumbnail"></dxi-file-manager-column>
<dxi-file-manager-column dataField="name"></dxi-file-manager-column>
<dxi-file-manager-column
dataField="dateModified"
caption="Modified"
></dxi-file-manager-column>
<dxi-file-manager-column
dataField="created"
caption="Created"
dataType="date"
></dxi-file-manager-column>
<dxi-file-manager-column
dataField="modifiedBy"
caption="Modified By"
visibleIndex="2"
></dxi-file-manager-column>
</dxo-file-manager-details>
</dxo-file-manager-item-view>
</dx-file-manager>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxFileManagerModule } from 'devextreme-angular';
import RemoteFileSystemProvider from 'devextreme/file_management/remote_provider';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
styleUrls: [`app/app.component.css`],
selector: 'demo-app',
templateUrl: `app/app.component.html`,
preserveWhitespaces: true,
imports: [
DxFileManagerModule,
],
})
export class AppComponent {
allowedFileExtensions: string[];
remoteProvider: RemoteFileSystemProvider;
constructor() {
this.allowedFileExtensions = [];
this.remoteProvider = new RemoteFileSystemProvider({
endpointUrl: 'https://js.devexpress.com/Demos/NetCore/api/file-manager-db',
});
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-gantt.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
using DevExtreme.AspNet.Mvc.FileManagement;
using DevExtreme.MVC.Demos.Models.FileManagement;
using System;
using System.Web;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class FileManagerDbProviderApiController : ApiController {
[AcceptVerbs("GET", "POST")]
[Route("api/file-manager-db", Name = "FileManagerDBProviderApi")]
public object Process(FileSystemCommand command, string arguments) {
var request = new HttpContextWrapper(HttpContext.Current).Request;
var config = new FileSystemConfiguration {
Request = request,
FileSystemProvider = new DbFileProvider(),
AllowCopy = true,
AllowCreate = true,
AllowMove = true,
AllowDelete = true,
AllowRename = true,
AllowedFileExtensions = new string[0]
};
var processor = new FileSystemCommandProcessor(config);
var result = processor.Execute(command, arguments);
return Ok(result.GetClientCommandResult());
}
}
}
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using DevExtreme.AspNet.Mvc.FileManagement;
namespace DevExtreme.MVC.Demos.Models.FileManagement {
public class DbFileProvider : IFileSystemItemLoader, IFileSystemItemEditor {
const int GuestPersonId = 1;
public DbFileProvider() {
FileManagementDbContext = new InMemoryFileManagementDataContext();
}
InMemoryFileManagementDataContext FileManagementDbContext { get; }
public IEnumerable<FileSystemItem> GetItems(FileSystemLoadItemOptions options) {
int parentId = ParseKey(options.Directory.Key);
var fileItems = GetDirectoryContents(parentId);
var hasSubDirectoriesInfo = GetHasSubDirectoriesInfo(fileItems);
var clientItemList = new List<FileSystemItem>();
foreach(var item in fileItems) {
var clientItem = new FileSystemItem {
Key = item.Id.ToString(),
Name = item.Name,
IsDirectory = item.IsDirectory,
DateModified = item.Modified
};
if(item.IsDirectory) {
clientItem.HasSubDirectories = hasSubDirectoriesInfo.ContainsKey(item.Id) && hasSubDirectoriesInfo[item.Id];
}
clientItem.CustomFields["modifiedBy"] = item.ModifiedBy.FullName;
clientItem.CustomFields["created"] = item.Created;
clientItemList.Add(clientItem);
}
return clientItemList;
}
public void CreateDirectory(FileSystemCreateDirectoryOptions options) {
var parentDirectory = options.ParentDirectory;
if(!IsFileItemExists(parentDirectory))
ThrowItemNotFoundException(parentDirectory);
var directory = new FileItem {
Name = options.DirectoryName,
Modified = DateTime.Now,
Created = DateTime.Now,
IsDirectory = true,
ParentId = ParseKey(parentDirectory.Key),
ModifiedById = GuestPersonId
};
FileManagementDbContext.FileItems.Add(directory);
FileManagementDbContext.SaveChanges();
}
public void RenameItem(FileSystemRenameItemOptions options) {
var item = options.Item;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
var fileItem = GetFileItem(item);
fileItem.Name = options.ItemNewName;
fileItem.ModifiedById = GuestPersonId;
fileItem.Modified = DateTime.Now;
FileManagementDbContext.SaveChanges();
}
public void MoveItem(FileSystemMoveItemOptions options) {
var item = options.Item;
var destinationDirectory = options.DestinationDirectory;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
if(!IsFileItemExists(destinationDirectory))
ThrowItemNotFoundException(destinationDirectory);
if(!AllowCopyOrMove(item, destinationDirectory))
ThrowNoAccessException();
var fileItem = GetFileItem(item);
fileItem.ParentId = ParseKey(destinationDirectory.Key);
fileItem.Modified = DateTime.Now;
fileItem.ModifiedById = GuestPersonId;
FileManagementDbContext.SaveChanges();
}
public void CopyItem(FileSystemCopyItemOptions options) {
var item = options.Item;
var destinationDirectory = options.DestinationDirectory;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
if(!IsFileItemExists(destinationDirectory))
ThrowItemNotFoundException(destinationDirectory);
if(!AllowCopyOrMove(item, destinationDirectory))
ThrowNoAccessException();
var sourceFileItem = GetFileItem(item);
var copyFileItem = CreateCopy(sourceFileItem);
copyFileItem.ParentId = ParseKey(destinationDirectory.Key);
copyFileItem.Name = GenerateCopiedFileItemName(copyFileItem.ParentId, copyFileItem.Name, copyFileItem.IsDirectory);
FileManagementDbContext.FileItems.Add(copyFileItem);
if(copyFileItem.IsDirectory)
CopyDirectoryContentRecursive(sourceFileItem, copyFileItem);
FileManagementDbContext.SaveChanges();
}
void CopyDirectoryContentRecursive(FileItem sourcePathInfo, FileItem destinationPathInfo) {
foreach(var fileItem in GetDirectoryContents(sourcePathInfo.Id)) {
var copyItem = CreateCopy(fileItem);
copyItem.Parent = destinationPathInfo;
FileManagementDbContext.FileItems.Add(copyItem);
if(fileItem.IsDirectory)
CopyDirectoryContentRecursive(fileItem, copyItem);
}
}
public void DeleteItem(FileSystemDeleteItemOptions options) {
var item = options.Item;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
var fileItem = GetFileItem(item);
FileManagementDbContext.FileItems.Remove(fileItem);
if(fileItem.IsDirectory)
RemoveDirectoryContentRecursive(fileItem.Id);
FileManagementDbContext.SaveChanges();
}
void RemoveDirectoryContentRecursive(int parenDirectoryKey) {
var itemsToRemove = FileManagementDbContext
.FileItems
.Where(item => item.ParentId == parenDirectoryKey)
.Select(item => new FileItem {
Id = item.Id,
IsDirectory = item.IsDirectory
});
foreach(var item in itemsToRemove) {
FileManagementDbContext.FileItems.Remove(item);
}
foreach(var item in itemsToRemove) {
if(!item.IsDirectory) continue;
RemoveDirectoryContentRecursive(item.Id);
}
}
IEnumerable<FileItem> GetDirectoryContents(int parentKey) {
return FileManagementDbContext.FileItems
.OrderByDescending(item => item.IsDirectory)
.ThenBy(item => item.Name)
.Where(items => items.ParentId == parentKey);
}
IDictionary<int, bool> GetHasSubDirectoriesInfo(IEnumerable<FileItem> fileItems) {
var keys = fileItems.Select(i => i.Id).ToArray();
return FileManagementDbContext.FileItems
.Where(item => item.IsDirectory)
.GroupBy(i => i.ParentId)
.Where(i => keys.Contains(i.Key))
.ToDictionary(group => group.Key, group => group.Any());
}
FileItem GetFileItem(FileSystemItemInfo item) {
var itemId = ParseKey(item.Key);
return FileManagementDbContext.FileItems.FirstOrDefault(i => i.Id == itemId);
}
bool IsFileItemExists(FileSystemItemInfo itemInfo) {
var pathKeys = itemInfo.PathKeys.Select(key => ParseKey(key)).ToArray();
var foundEntries = FileManagementDbContext.FileItems
.Where(item => pathKeys.Contains(item.Id))
.Select(item => new { item.Id, item.ParentId, item.Name, item.IsDirectory });
var pathNames = itemInfo.Path.Split(new[] { Path.DirectorySeparatorChar }, StringSplitOptions.RemoveEmptyEntries);
var isDirectoryExists = true;
for(var i = 0; i < pathKeys.Length && isDirectoryExists; i++) {
var entry = foundEntries.FirstOrDefault(e => e.Id == pathKeys[i]);
isDirectoryExists = entry != null && entry.Name == pathNames[i] &&
(i == 0 && entry.ParentId == 0 || entry.ParentId == pathKeys[i - 1]);
if(isDirectoryExists && i < pathKeys.Length - 1)
isDirectoryExists = entry.IsDirectory;
}
return isDirectoryExists;
}
static bool AllowCopyOrMove(FileSystemItemInfo item, FileSystemItemInfo destinationDirectory) {
if(destinationDirectory.PathKeys.Length < item.PathKeys.Length)
return true;
var isValid = false;
for(var i = 0; i < destinationDirectory.PathKeys.Length && !isValid; i++) {
isValid = destinationDirectory.PathKeys[i] != item.PathKeys[i];
}
return isValid;
}
static FileItem CreateCopy(FileItem fileItem) {
return new FileItem {
Name = fileItem.Name,
Created = DateTime.Now,
Modified = DateTime.Now,
IsDirectory = fileItem.IsDirectory,
ModifiedById = GuestPersonId
};
}
static int ParseKey(string key) {
return string.IsNullOrEmpty(key) ? 0 : int.Parse(key);
}
string GenerateCopiedFileItemName(int parentDirKey, string copiedFileItemName, bool isDirectory) {
var dirNames = GetDirectoryContents(parentDirKey)
.Where(i => i.IsDirectory == isDirectory)
.Select(i => i.Name);
string newName;
var fileExtension = isDirectory ? "" : "." + Path.GetExtension(copiedFileItemName);
var copyNamePrefix =
isDirectory ? copiedFileItemName : Path.GetFileNameWithoutExtension(copiedFileItemName);
var index = -1;
do {
var pathPostfix = index < 1 ? string.Empty : $" {index}{fileExtension}";
newName = $"{copyNamePrefix} {(index < 0 ? "" : "copy")}{pathPostfix}";
index++;
} while(dirNames.Contains(newName));
return newName;
}
void ThrowItemNotFoundException(FileSystemItemInfo item) {
var itemType = item.IsDirectory ? "Directory" : "File";
var errorCode = item.IsDirectory ? FileSystemErrorCode.DirectoryNotFound : FileSystemErrorCode.FileNotFound;
string message = $"{itemType} '{item.Path}' not found.";
throw new FileSystemException(errorCode, message);
}
void ThrowNoAccessException() {
string message = "Access denied. The operation cannot be completed.";
throw new FileSystemException(FileSystemErrorCode.NoAccess, message);
}
}
}

Backend API
<template>
<DxFileManager
:file-system-provider="remoteProvider"
:allowed-file-extensions="allowedFileExtensions"
:height="550"
current-path="Documents/Reports"
>
<DxPermissions
:create="true"
:copy="true"
:move="true"
:delete="true"
:rename="true"
/>
<DxItemView>
<DxDetails>
<DxColumn data-field="thumbnail"/>
<DxColumn data-field="name"/>
<DxColumn
data-field="dateModified"
caption="Modified"
/>
<DxColumn
data-field="created"
caption="Created"
data-type="date"
/>
<DxColumn
data-field="modifiedBy"
caption="Modified By"
:visible-index="2"
/>
</DxDetails>
</DxItemView>
</DxFileManager>
</template>
<script setup lang="ts">
import {
DxFileManager, DxPermissions, DxItemView, DxDetails, DxColumn,
} from 'devextreme-vue/file-manager';
import RemoteFileSystemProvider from 'devextreme/file_management/remote_provider';
const remoteProvider = new RemoteFileSystemProvider({
endpointUrl: 'https://js.devexpress.com/Demos/NetCore/api/file-manager-db',
});
const allowedFileExtensions: string[] = [];
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-gantt.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
using DevExtreme.AspNet.Mvc.FileManagement;
using DevExtreme.MVC.Demos.Models.FileManagement;
using System;
using System.Web;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class FileManagerDbProviderApiController : ApiController {
[AcceptVerbs("GET", "POST")]
[Route("api/file-manager-db", Name = "FileManagerDBProviderApi")]
public object Process(FileSystemCommand command, string arguments) {
var request = new HttpContextWrapper(HttpContext.Current).Request;
var config = new FileSystemConfiguration {
Request = request,
FileSystemProvider = new DbFileProvider(),
AllowCopy = true,
AllowCreate = true,
AllowMove = true,
AllowDelete = true,
AllowRename = true,
AllowedFileExtensions = new string[0]
};
var processor = new FileSystemCommandProcessor(config);
var result = processor.Execute(command, arguments);
return Ok(result.GetClientCommandResult());
}
}
}
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using DevExtreme.AspNet.Mvc.FileManagement;
namespace DevExtreme.MVC.Demos.Models.FileManagement {
public class DbFileProvider : IFileSystemItemLoader, IFileSystemItemEditor {
const int GuestPersonId = 1;
public DbFileProvider() {
FileManagementDbContext = new InMemoryFileManagementDataContext();
}
InMemoryFileManagementDataContext FileManagementDbContext { get; }
public IEnumerable<FileSystemItem> GetItems(FileSystemLoadItemOptions options) {
int parentId = ParseKey(options.Directory.Key);
var fileItems = GetDirectoryContents(parentId);
var hasSubDirectoriesInfo = GetHasSubDirectoriesInfo(fileItems);
var clientItemList = new List<FileSystemItem>();
foreach(var item in fileItems) {
var clientItem = new FileSystemItem {
Key = item.Id.ToString(),
Name = item.Name,
IsDirectory = item.IsDirectory,
DateModified = item.Modified
};
if(item.IsDirectory) {
clientItem.HasSubDirectories = hasSubDirectoriesInfo.ContainsKey(item.Id) && hasSubDirectoriesInfo[item.Id];
}
clientItem.CustomFields["modifiedBy"] = item.ModifiedBy.FullName;
clientItem.CustomFields["created"] = item.Created;
clientItemList.Add(clientItem);
}
return clientItemList;
}
public void CreateDirectory(FileSystemCreateDirectoryOptions options) {
var parentDirectory = options.ParentDirectory;
if(!IsFileItemExists(parentDirectory))
ThrowItemNotFoundException(parentDirectory);
var directory = new FileItem {
Name = options.DirectoryName,
Modified = DateTime.Now,
Created = DateTime.Now,
IsDirectory = true,
ParentId = ParseKey(parentDirectory.Key),
ModifiedById = GuestPersonId
};
FileManagementDbContext.FileItems.Add(directory);
FileManagementDbContext.SaveChanges();
}
public void RenameItem(FileSystemRenameItemOptions options) {
var item = options.Item;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
var fileItem = GetFileItem(item);
fileItem.Name = options.ItemNewName;
fileItem.ModifiedById = GuestPersonId;
fileItem.Modified = DateTime.Now;
FileManagementDbContext.SaveChanges();
}
public void MoveItem(FileSystemMoveItemOptions options) {
var item = options.Item;
var destinationDirectory = options.DestinationDirectory;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
if(!IsFileItemExists(destinationDirectory))
ThrowItemNotFoundException(destinationDirectory);
if(!AllowCopyOrMove(item, destinationDirectory))
ThrowNoAccessException();
var fileItem = GetFileItem(item);
fileItem.ParentId = ParseKey(destinationDirectory.Key);
fileItem.Modified = DateTime.Now;
fileItem.ModifiedById = GuestPersonId;
FileManagementDbContext.SaveChanges();
}
public void CopyItem(FileSystemCopyItemOptions options) {
var item = options.Item;
var destinationDirectory = options.DestinationDirectory;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
if(!IsFileItemExists(destinationDirectory))
ThrowItemNotFoundException(destinationDirectory);
if(!AllowCopyOrMove(item, destinationDirectory))
ThrowNoAccessException();
var sourceFileItem = GetFileItem(item);
var copyFileItem = CreateCopy(sourceFileItem);
copyFileItem.ParentId = ParseKey(destinationDirectory.Key);
copyFileItem.Name = GenerateCopiedFileItemName(copyFileItem.ParentId, copyFileItem.Name, copyFileItem.IsDirectory);
FileManagementDbContext.FileItems.Add(copyFileItem);
if(copyFileItem.IsDirectory)
CopyDirectoryContentRecursive(sourceFileItem, copyFileItem);
FileManagementDbContext.SaveChanges();
}
void CopyDirectoryContentRecursive(FileItem sourcePathInfo, FileItem destinationPathInfo) {
foreach(var fileItem in GetDirectoryContents(sourcePathInfo.Id)) {
var copyItem = CreateCopy(fileItem);
copyItem.Parent = destinationPathInfo;
FileManagementDbContext.FileItems.Add(copyItem);
if(fileItem.IsDirectory)
CopyDirectoryContentRecursive(fileItem, copyItem);
}
}
public void DeleteItem(FileSystemDeleteItemOptions options) {
var item = options.Item;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
var fileItem = GetFileItem(item);
FileManagementDbContext.FileItems.Remove(fileItem);
if(fileItem.IsDirectory)
RemoveDirectoryContentRecursive(fileItem.Id);
FileManagementDbContext.SaveChanges();
}
void RemoveDirectoryContentRecursive(int parenDirectoryKey) {
var itemsToRemove = FileManagementDbContext
.FileItems
.Where(item => item.ParentId == parenDirectoryKey)
.Select(item => new FileItem {
Id = item.Id,
IsDirectory = item.IsDirectory
});
foreach(var item in itemsToRemove) {
FileManagementDbContext.FileItems.Remove(item);
}
foreach(var item in itemsToRemove) {
if(!item.IsDirectory) continue;
RemoveDirectoryContentRecursive(item.Id);
}
}
IEnumerable<FileItem> GetDirectoryContents(int parentKey) {
return FileManagementDbContext.FileItems
.OrderByDescending(item => item.IsDirectory)
.ThenBy(item => item.Name)
.Where(items => items.ParentId == parentKey);
}
IDictionary<int, bool> GetHasSubDirectoriesInfo(IEnumerable<FileItem> fileItems) {
var keys = fileItems.Select(i => i.Id).ToArray();
return FileManagementDbContext.FileItems
.Where(item => item.IsDirectory)
.GroupBy(i => i.ParentId)
.Where(i => keys.Contains(i.Key))
.ToDictionary(group => group.Key, group => group.Any());
}
FileItem GetFileItem(FileSystemItemInfo item) {
var itemId = ParseKey(item.Key);
return FileManagementDbContext.FileItems.FirstOrDefault(i => i.Id == itemId);
}
bool IsFileItemExists(FileSystemItemInfo itemInfo) {
var pathKeys = itemInfo.PathKeys.Select(key => ParseKey(key)).ToArray();
var foundEntries = FileManagementDbContext.FileItems
.Where(item => pathKeys.Contains(item.Id))
.Select(item => new { item.Id, item.ParentId, item.Name, item.IsDirectory });
var pathNames = itemInfo.Path.Split(new[] { Path.DirectorySeparatorChar }, StringSplitOptions.RemoveEmptyEntries);
var isDirectoryExists = true;
for(var i = 0; i < pathKeys.Length && isDirectoryExists; i++) {
var entry = foundEntries.FirstOrDefault(e => e.Id == pathKeys[i]);
isDirectoryExists = entry != null && entry.Name == pathNames[i] &&
(i == 0 && entry.ParentId == 0 || entry.ParentId == pathKeys[i - 1]);
if(isDirectoryExists && i < pathKeys.Length - 1)
isDirectoryExists = entry.IsDirectory;
}
return isDirectoryExists;
}
static bool AllowCopyOrMove(FileSystemItemInfo item, FileSystemItemInfo destinationDirectory) {
if(destinationDirectory.PathKeys.Length < item.PathKeys.Length)
return true;
var isValid = false;
for(var i = 0; i < destinationDirectory.PathKeys.Length && !isValid; i++) {
isValid = destinationDirectory.PathKeys[i] != item.PathKeys[i];
}
return isValid;
}
static FileItem CreateCopy(FileItem fileItem) {
return new FileItem {
Name = fileItem.Name,
Created = DateTime.Now,
Modified = DateTime.Now,
IsDirectory = fileItem.IsDirectory,
ModifiedById = GuestPersonId
};
}
static int ParseKey(string key) {
return string.IsNullOrEmpty(key) ? 0 : int.Parse(key);
}
string GenerateCopiedFileItemName(int parentDirKey, string copiedFileItemName, bool isDirectory) {
var dirNames = GetDirectoryContents(parentDirKey)
.Where(i => i.IsDirectory == isDirectory)
.Select(i => i.Name);
string newName;
var fileExtension = isDirectory ? "" : "." + Path.GetExtension(copiedFileItemName);
var copyNamePrefix =
isDirectory ? copiedFileItemName : Path.GetFileNameWithoutExtension(copiedFileItemName);
var index = -1;
do {
var pathPostfix = index < 1 ? string.Empty : $" {index}{fileExtension}";
newName = $"{copyNamePrefix} {(index < 0 ? "" : "copy")}{pathPostfix}";
index++;
} while(dirNames.Contains(newName));
return newName;
}
void ThrowItemNotFoundException(FileSystemItemInfo item) {
var itemType = item.IsDirectory ? "Directory" : "File";
var errorCode = item.IsDirectory ? FileSystemErrorCode.DirectoryNotFound : FileSystemErrorCode.FileNotFound;
string message = $"{itemType} '{item.Path}' not found.";
throw new FileSystemException(errorCode, message);
}
void ThrowNoAccessException() {
string message = "Access denied. The operation cannot be completed.";
throw new FileSystemException(FileSystemErrorCode.NoAccess, message);
}
}
}

Backend API
import React, { useCallback, useState } from 'react';
import FileManager, {
Permissions, ItemView, Details, Column,
} from 'devextreme-react/file-manager';
import type { FileManagerTypes } from 'devextreme-react/file-manager';
import RemoteFileSystemProvider from 'devextreme/file_management/remote_provider';
const remoteProvider = new RemoteFileSystemProvider({
endpointUrl: 'https://js.devexpress.com/Demos/NetCore/api/file-manager-db',
});
const allowedFileExtensions: string[] = [];
export default function App() {
const [currentPath, setCurrentPath] = useState<string>('Documents/Reports');
const onCurrentDirectoryChanged = useCallback((e: FileManagerTypes.CurrentDirectoryChangedEvent) => {
const path = e?.component?.option('currentPath');
path && setCurrentPath(path);
}, []);
return (
<FileManager
currentPath={currentPath}
fileSystemProvider={remoteProvider}
allowedFileExtensions={allowedFileExtensions}
height={550}
onCurrentDirectoryChanged={onCurrentDirectoryChanged}>
<Permissions
create={true}
copy={true}
move={true}
delete={true}
rename={true}>
</Permissions>
<ItemView>
<Details>
<Column dataField="thumbnail"></Column>
<Column dataField="name"></Column>
<Column dataField="dateModified" caption="Modified"></Column>
<Column dataField="created" caption="Created" dataType="date"></Column>
<Column dataField="modifiedBy" caption="Modified By" visibleIndex={2}></Column>
</Details>
</ItemView>
</FileManager>
);
}
import React, { useCallback, useState } from 'react';
import FileManager, {
Permissions, ItemView, Details, Column,
} from 'devextreme-react/file-manager';
import RemoteFileSystemProvider from 'devextreme/file_management/remote_provider';
const remoteProvider = new RemoteFileSystemProvider({
endpointUrl: 'https://js.devexpress.com/Demos/NetCore/api/file-manager-db',
});
const allowedFileExtensions = [];
export default function App() {
const [currentPath, setCurrentPath] = useState('Documents/Reports');
const onCurrentDirectoryChanged = useCallback((e) => {
const path = e?.component?.option('currentPath');
path && setCurrentPath(path);
}, []);
return (
<FileManager
currentPath={currentPath}
fileSystemProvider={remoteProvider}
allowedFileExtensions={allowedFileExtensions}
height={550}
onCurrentDirectoryChanged={onCurrentDirectoryChanged}
>
<Permissions
create={true}
copy={true}
move={true}
delete={true}
rename={true}
></Permissions>
<ItemView>
<Details>
<Column dataField="thumbnail"></Column>
<Column dataField="name"></Column>
<Column
dataField="dateModified"
caption="Modified"
></Column>
<Column
dataField="created"
caption="Created"
dataType="date"
></Column>
<Column
dataField="modifiedBy"
caption="Modified By"
visibleIndex={2}
></Column>
</Details>
</ItemView>
</FileManager>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-gantt.min.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
<link rel="stylesheet" type="text/css" href="styles.css" />
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
using DevExtreme.AspNet.Mvc.FileManagement;
using DevExtreme.MVC.Demos.Models.FileManagement;
using System;
using System.Web;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
public class FileManagerDbProviderApiController : ApiController {
[AcceptVerbs("GET", "POST")]
[Route("api/file-manager-db", Name = "FileManagerDBProviderApi")]
public object Process(FileSystemCommand command, string arguments) {
var request = new HttpContextWrapper(HttpContext.Current).Request;
var config = new FileSystemConfiguration {
Request = request,
FileSystemProvider = new DbFileProvider(),
AllowCopy = true,
AllowCreate = true,
AllowMove = true,
AllowDelete = true,
AllowRename = true,
AllowedFileExtensions = new string[0]
};
var processor = new FileSystemCommandProcessor(config);
var result = processor.Execute(command, arguments);
return Ok(result.GetClientCommandResult());
}
}
}
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using DevExtreme.AspNet.Mvc.FileManagement;
namespace DevExtreme.MVC.Demos.Models.FileManagement {
public class DbFileProvider : IFileSystemItemLoader, IFileSystemItemEditor {
const int GuestPersonId = 1;
public DbFileProvider() {
FileManagementDbContext = new InMemoryFileManagementDataContext();
}
InMemoryFileManagementDataContext FileManagementDbContext { get; }
public IEnumerable<FileSystemItem> GetItems(FileSystemLoadItemOptions options) {
int parentId = ParseKey(options.Directory.Key);
var fileItems = GetDirectoryContents(parentId);
var hasSubDirectoriesInfo = GetHasSubDirectoriesInfo(fileItems);
var clientItemList = new List<FileSystemItem>();
foreach(var item in fileItems) {
var clientItem = new FileSystemItem {
Key = item.Id.ToString(),
Name = item.Name,
IsDirectory = item.IsDirectory,
DateModified = item.Modified
};
if(item.IsDirectory) {
clientItem.HasSubDirectories = hasSubDirectoriesInfo.ContainsKey(item.Id) && hasSubDirectoriesInfo[item.Id];
}
clientItem.CustomFields["modifiedBy"] = item.ModifiedBy.FullName;
clientItem.CustomFields["created"] = item.Created;
clientItemList.Add(clientItem);
}
return clientItemList;
}
public void CreateDirectory(FileSystemCreateDirectoryOptions options) {
var parentDirectory = options.ParentDirectory;
if(!IsFileItemExists(parentDirectory))
ThrowItemNotFoundException(parentDirectory);
var directory = new FileItem {
Name = options.DirectoryName,
Modified = DateTime.Now,
Created = DateTime.Now,
IsDirectory = true,
ParentId = ParseKey(parentDirectory.Key),
ModifiedById = GuestPersonId
};
FileManagementDbContext.FileItems.Add(directory);
FileManagementDbContext.SaveChanges();
}
public void RenameItem(FileSystemRenameItemOptions options) {
var item = options.Item;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
var fileItem = GetFileItem(item);
fileItem.Name = options.ItemNewName;
fileItem.ModifiedById = GuestPersonId;
fileItem.Modified = DateTime.Now;
FileManagementDbContext.SaveChanges();
}
public void MoveItem(FileSystemMoveItemOptions options) {
var item = options.Item;
var destinationDirectory = options.DestinationDirectory;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
if(!IsFileItemExists(destinationDirectory))
ThrowItemNotFoundException(destinationDirectory);
if(!AllowCopyOrMove(item, destinationDirectory))
ThrowNoAccessException();
var fileItem = GetFileItem(item);
fileItem.ParentId = ParseKey(destinationDirectory.Key);
fileItem.Modified = DateTime.Now;
fileItem.ModifiedById = GuestPersonId;
FileManagementDbContext.SaveChanges();
}
public void CopyItem(FileSystemCopyItemOptions options) {
var item = options.Item;
var destinationDirectory = options.DestinationDirectory;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
if(!IsFileItemExists(destinationDirectory))
ThrowItemNotFoundException(destinationDirectory);
if(!AllowCopyOrMove(item, destinationDirectory))
ThrowNoAccessException();
var sourceFileItem = GetFileItem(item);
var copyFileItem = CreateCopy(sourceFileItem);
copyFileItem.ParentId = ParseKey(destinationDirectory.Key);
copyFileItem.Name = GenerateCopiedFileItemName(copyFileItem.ParentId, copyFileItem.Name, copyFileItem.IsDirectory);
FileManagementDbContext.FileItems.Add(copyFileItem);
if(copyFileItem.IsDirectory)
CopyDirectoryContentRecursive(sourceFileItem, copyFileItem);
FileManagementDbContext.SaveChanges();
}
void CopyDirectoryContentRecursive(FileItem sourcePathInfo, FileItem destinationPathInfo) {
foreach(var fileItem in GetDirectoryContents(sourcePathInfo.Id)) {
var copyItem = CreateCopy(fileItem);
copyItem.Parent = destinationPathInfo;
FileManagementDbContext.FileItems.Add(copyItem);
if(fileItem.IsDirectory)
CopyDirectoryContentRecursive(fileItem, copyItem);
}
}
public void DeleteItem(FileSystemDeleteItemOptions options) {
var item = options.Item;
if(!IsFileItemExists(item))
ThrowItemNotFoundException(item);
var fileItem = GetFileItem(item);
FileManagementDbContext.FileItems.Remove(fileItem);
if(fileItem.IsDirectory)
RemoveDirectoryContentRecursive(fileItem.Id);
FileManagementDbContext.SaveChanges();
}
void RemoveDirectoryContentRecursive(int parenDirectoryKey) {
var itemsToRemove = FileManagementDbContext
.FileItems
.Where(item => item.ParentId == parenDirectoryKey)
.Select(item => new FileItem {
Id = item.Id,
IsDirectory = item.IsDirectory
});
foreach(var item in itemsToRemove) {
FileManagementDbContext.FileItems.Remove(item);
}
foreach(var item in itemsToRemove) {
if(!item.IsDirectory) continue;
RemoveDirectoryContentRecursive(item.Id);
}
}
IEnumerable<FileItem> GetDirectoryContents(int parentKey) {
return FileManagementDbContext.FileItems
.OrderByDescending(item => item.IsDirectory)
.ThenBy(item => item.Name)
.Where(items => items.ParentId == parentKey);
}
IDictionary<int, bool> GetHasSubDirectoriesInfo(IEnumerable<FileItem> fileItems) {
var keys = fileItems.Select(i => i.Id).ToArray();
return FileManagementDbContext.FileItems
.Where(item => item.IsDirectory)
.GroupBy(i => i.ParentId)
.Where(i => keys.Contains(i.Key))
.ToDictionary(group => group.Key, group => group.Any());
}
FileItem GetFileItem(FileSystemItemInfo item) {
var itemId = ParseKey(item.Key);
return FileManagementDbContext.FileItems.FirstOrDefault(i => i.Id == itemId);
}
bool IsFileItemExists(FileSystemItemInfo itemInfo) {
var pathKeys = itemInfo.PathKeys.Select(key => ParseKey(key)).ToArray();
var foundEntries = FileManagementDbContext.FileItems
.Where(item => pathKeys.Contains(item.Id))
.Select(item => new { item.Id, item.ParentId, item.Name, item.IsDirectory });
var pathNames = itemInfo.Path.Split(new[] { Path.DirectorySeparatorChar }, StringSplitOptions.RemoveEmptyEntries);
var isDirectoryExists = true;
for(var i = 0; i < pathKeys.Length && isDirectoryExists; i++) {
var entry = foundEntries.FirstOrDefault(e => e.Id == pathKeys[i]);
isDirectoryExists = entry != null && entry.Name == pathNames[i] &&
(i == 0 && entry.ParentId == 0 || entry.ParentId == pathKeys[i - 1]);
if(isDirectoryExists && i < pathKeys.Length - 1)
isDirectoryExists = entry.IsDirectory;
}
return isDirectoryExists;
}
static bool AllowCopyOrMove(FileSystemItemInfo item, FileSystemItemInfo destinationDirectory) {
if(destinationDirectory.PathKeys.Length < item.PathKeys.Length)
return true;
var isValid = false;
for(var i = 0; i < destinationDirectory.PathKeys.Length && !isValid; i++) {
isValid = destinationDirectory.PathKeys[i] != item.PathKeys[i];
}
return isValid;
}
static FileItem CreateCopy(FileItem fileItem) {
return new FileItem {
Name = fileItem.Name,
Created = DateTime.Now,
Modified = DateTime.Now,
IsDirectory = fileItem.IsDirectory,
ModifiedById = GuestPersonId
};
}
static int ParseKey(string key) {
return string.IsNullOrEmpty(key) ? 0 : int.Parse(key);
}
string GenerateCopiedFileItemName(int parentDirKey, string copiedFileItemName, bool isDirectory) {
var dirNames = GetDirectoryContents(parentDirKey)
.Where(i => i.IsDirectory == isDirectory)
.Select(i => i.Name);
string newName;
var fileExtension = isDirectory ? "" : "." + Path.GetExtension(copiedFileItemName);
var copyNamePrefix =
isDirectory ? copiedFileItemName : Path.GetFileNameWithoutExtension(copiedFileItemName);
var index = -1;
do {
var pathPostfix = index < 1 ? string.Empty : $" {index}{fileExtension}";
newName = $"{copyNamePrefix} {(index < 0 ? "" : "copy")}{pathPostfix}";
index++;
} while(dirNames.Contains(newName));
return newName;
}
void ThrowItemNotFoundException(FileSystemItemInfo item) {
var itemType = item.IsDirectory ? "Directory" : "File";
var errorCode = item.IsDirectory ? FileSystemErrorCode.DirectoryNotFound : FileSystemErrorCode.FileNotFound;
string message = $"{itemType} '{item.Path}' not found.";
throw new FileSystemException(errorCode, message);
}
void ThrowNoAccessException() {
string message = "Access denied. The operation cannot be completed.";
throw new FileSystemException(FileSystemErrorCode.NoAccess, message);
}
}
}